#!/usr/bin/perl

#written by inquis for the forms at http://www.doom9.org
#modified by canadian_fbi. free for public use or re-use or abuse
#modified for divx5 by khp. free for public use or re-use or abuse

$pass_flag = 1;   # 1 = in first pass - may need to open new stats file for new movie
                     # 2 = in 2nd-pass, logging stats
$pass_count = 2;  # used to name additional second pass stats files

$infile = shift || "analyse.log";
$outfile = shift || "second_pass_stats.log";

#some spreadsheet applications like text data imported to be delimited by tabs, others commas
$delimiter = "\t";

#open the files for processing
open(INFILE,"<$infile") || die("can't open $infile\n");

#pull the quant data and dump it into the predefined buckets
print "dropping data into buckets... ";
$total_frames = 0;
$total_i_frames = 0;
$total_p_frames = 0;
$total_b_frames = 0;
$complexity = 0;
$texture = 0;
$frame = 0;
$quant = 0;
$expected = 0;
$achieved = 0;
open(OUTFILE,">$outfile");
$outfile = "second_pass_stats_.log";

while ($line1 = <INFILE>)  {
    if ($line1 =~ /Frame/) {
       	$total_frames++;
	$line2 = <INFILE>;
	$line1 =~ /complexity ([0-9]*)/;
	$complexity = $1;
	$line1 =~ /texture ([0-9]*)/;
	$texture = $1;
	$line1 =~ /Frame ([0-9]*)/;
	$frame = $1;
	$line1 =~ /total ([0-9]*)/;
	$total = $1;
	$line2 =~ /new quant ([0-9]*)/;
	$quant = $1;
	$line2 =~ /expected ([0-9]*)/;
	$expected = $1;
	$line2 =~ /achieved ([0-9]*)/;
	$achieved = $1;
	$diff = $expected - $achieved; 
	$quant_array[$quant]++;
	if ($line1 =~ /PRESENT \(I\)/) {
	    $i_frame_array[$quant]++;
	    $total_i_frames++;
	    $i_frame_texture += $texture;
	    $i_frame_complexity += $complexity;
	    $i_frame_total += $total;
	} else {
	    if ($line1 =~ /PRESENT \(P\)/) {
		$p_frame_array[$quant]++;
		$total_p_frames++;
		$p_frame_texture += $texture;
		$p_frame_complexity += $complexity;
		$p_frame_total += $total;
	    } else {
		$b_frame_array[$quant]++;
		$total_b_frames++;
		$b_frame_texture += $texture;
		$b_frame_complexity += $complexity;
		$b_frame_total += $total;
	    }
	}
    }
}
print "done\n";
print "total number of frames:" . $total_frames . "\n";


#now write output to file

print "writing output to second_pass_stats.log \n";
print OUTFILE "total number of frames:" . $total_frames . "\n";
print OUTFILE "total number of i-frames:" . $total_i_frames . "  Average size: " . $i_frame_total / $total_i_frames . "\n";
print OUTFILE "total number of p-frames:" . $total_p_frames . " Average size: " . $p_frame_total / $total_p_frames . "\n";
if ($total_b_frames > 0) {
print OUTFILE "total number of b-frames:" . $total_b_frames . " Average size: " . $b_frame_total / $total_b_frames . "\n";}
if ($expected > $achived) {
    print OUTFILE "File was undersized by: " . $expected - $achived . " bits\n"; 
}
else {
    print OUTFILE "File was oversized by: " . $achived - $expected . " bits\n";
}
print OUTFILE "lower quant = higher quality\n\n";

#output number of frames of each quant plus avg. quant for all frames
print OUTFILE "quant\tnumber of frames\n";
$avg_quant = 0;
for ($i = 1; $i <= $#quant_array; $i++)  {
    if ($i < 32 && $quant_array[$i]) {
	print OUTFILE "$i" . "$delimiter" . "$quant_array[$i]\n";
	$avg_quant = $avg_quant + $i * $quant_array[$i];
    }
}
$avg_quant /= $total_frames;
print OUTFILE "average quant = $avg_quant\n\n";

#now just for the i-frames, then p-frames
print OUTFILE "quant\tnumber of i-frames\n";
$avg_quant = 0;
for ($i = 1; $i <= $#i_frame_array; $i++)  {
    if (i<32 && $i_frame_array[$i]) { 
	print OUTFILE "$i" . "$delimiter" . "$i_frame_array[$i]\n";
	$avg_quant = $avg_quant + $i * $i_frame_array[$i];
    }
}

$avg_quant /= $total_i_frames;
print OUTFILE "average i-frame quant = $avg_quant\n\n";

print OUTFILE "quant\tnumber of p-frames\n";
$avg_quant = 0;
for ($i = 1; $i <= $#p_frame_array; $i++)  {
    if ($i < 32 && $p_frame_array[$i]) {
	print OUTFILE "$i" . "$delimiter" . "$p_frame_array[$i]\n";
	$avg_quant = $avg_quant + $i * $p_frame_array[$i];
    }
}
$avg_quant /= $total_p_frames;
print OUTFILE "average p-frame quant = $avg_quant\n\n";

print OUTFILE "quant\tnumber of b-frames\n";
$avg_quant = 0;
for ($i = 1; $i <= $#b_frame_array; $i++)  {
    if ($i < 32 && $b_frame_array[$i]) {
	print OUTFILE "$i" . "$delimiter" . "$b_frame_array[$i]\n";
	$avg_quant = $avg_quant + $i * $b_frame_array[$i];
    }
}
$avg_quant /= $total_b_frames;
print OUTFILE "average b-frame quant = $avg_quant\n\n";
print OUTFILE "By default the B-frame quantizers will be multiplied by 2\n";
print OUTFILE "This analasys does not take this into account\n";
print "done\n";

